# More digits so we can represented tensor monomials using integers.

options(digits=12)

# Permutations of 1:3

per <- rbind(   c(1,2,3),

                c(2,1,3),
                c(3,2,1),
                c(1,3,2),
                
                c(2,3,1),
                c(3,1,2)

                

                )

# Vector of the signature of a permutation.


ss <- c(1,rep(-1,3),rep(1,2))


 # Initialize indexing array "ind" for variables. This simply gives ind[i,j,k] a unique
  # value between 1 and 27 which we shift to between 10 and 36 for lookup purposes. 

  ind <- array(0,c(3,3,3))
  ca <- 9
  for(i in 1:3) for(j in 1:3) for(k in 1:3) { ca <- ca+1
                                              ind[i,j,k] <- ca }

 rm(ca,i,j,k)

# Function to check integer in loop counting.

check.integer <- function(x) {
                                  x == round(x)
                                                  }


# How big the computation is.

en <- 6^6

# Initialize terms

monos <- rep(NA,en)
cofs <- rep(NA,en)

cc <- 0






# Intialize a vector for the indivicual terms.

term <- vector(,length=6)


 # Intitialization of loop.

  K <- 1:6


# The main loop
# The idea is to set i1 in K from a batch.

      for(i1 in K)
      for(i2 in K)
      for(i3 in K)
      for(i4 in K)
      for(i5 in K)
      for(i6 in K)

      {


        term[1] <- ind[per[i1,1],per[i5,3],per[i6,2]]     # 10^5 takes 0.93s
        term[2] <- ind[per[i1,2],per[i2,1],per[i6,3]]
        term[3] <- ind[per[i1,3],per[i2,2],per[i3,1]]
        term[4] <- ind[per[i4,1],per[i2,3],per[i3,2]]
        term[5] <- ind[per[i4,2],per[i5,1],per[i3,3]]
        term[6] <- ind[per[i4,3],per[i5,2],per[i6,1]]
        


        # Sort variables and then sum into a unique integer representation.

        newterm <- sum((term[order(term)])*10^(c(10,8,6,4,2,0)))    # 10^5 takes 1.56s


        # Each coeff. Should be 1 or -1.

        newcof <- prod(ss[i1],ss[i2],ss[i3],ss[i4],ss[i5],ss[i6])    # 10^5 takes 0.5s

        # Now record each momonomial

        cc <- cc+1

        monos[cc] <- newterm                                      # 10^5 takes 0.44s
        cofs[cc] <- newcof                                        # 10^5 takes 0.44s








        }


tangle3 <- reduce(monos,cofs)

